package sys

import (
	"SSW_WebPlatform/web/middleware/casbins"
	"github.com/kataras/golog"
)

var (
	// 定义系统初始的角色
	Components = [][]string{
		{"admin", "/admin*", "GET|POST|DELETE|PUT"},
	}
)

// 创建系统默认角色
func CreateSystemRole() bool {
	e,err := casbins.NewCasbin()
	if err !=nil{
		golog.Fatalf("初始化权限失败。%v", err)
	}
	for _, v := range Components {
		p := e.GetFilteredPolicy(0, v[0])
		if len(p) == 0 {
			if ok,_ := e.AddPolicy(v); !ok {
				golog.Fatalf("初始化角色[%s]权限失败。%s", v)
			}
		}
	}
	return true
}
