package wxSmall

import (
	"SSW_WebPlatform/utils"
	"SSW_WebPlatform/utils/wxfunc"
	"SSW_WebPlatform/web/models"
	"SSW_WebPlatform/web/models/wxSmall"
	"SSW_WebPlatform/web/supports"
	"fmt"
	"github.com/kataras/iris/v12"
	"time"
)

//微信授权登录
func Wxlogin(ctx iris.Context) {

	data := new(wxSmall.UserData)
	if err := ctx.ReadJSON(data); err != nil {
		supports.Error(ctx, iris.StatusBadRequest, "json解析错误", nil)
		return
	}
	//code := data.Code //  获取code
	// 根据code获取 openID 和 session_key
	//wxLoginResp, err := wxfunc.WXLogin(code)
	//if err != nil {
	//	supports.Error(ctx, iris.StatusBadRequest, "获取session_key失败", nil)
	//	return
	//}

	//判断数据库里用户表是否存在此用户
	user := new(wxSmall.WxUser)
	//user.Openid = wxLoginResp.OpenId
	user.Openid = "123456"
	wxuser, err := user.SelectOneByOpenid()
	if err != nil {
		supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
		return
	}
	if wxuser == nil {
		//添加信息
		//userInfo, err := wxfunc.DecryptData(data.EncryptedData,data.Iv,wxLoginResp.SessionKey)
		//if  err != nil {
		//	supports.Error(ctx, iris.StatusBadRequest, "数据解密失败", nil)
		//	return
		//}
		//Info := userInfo.(map[string]interface{})
		//user.Nickname = utils.ValueToString(Info["nickName"],"")
		//user.Gender = utils.ValueToInt(Info["gender"],0)
		//user.Avatarurl = utils.ValueToString(Info["avatarUrl"],"")
		//user.Province = utils.ValueToString(Info["province"],"")
		//user.City =utils.ValueToString(Info["city"],"")
		//user.Country =utils.ValueToString(Info["country"],"")
		//user.Sessionkey = wxLoginResp.SessionKey
		//user.Openid = wxLoginResp.OpenId
		//user.Unionid = wxLoginResp.UnionId
		user.Gender = 1
		user.Nickname = "风云争霸"
		user.Sessionkey = "123456"
		user.Openid = "123456"
		user.Unionid = "123456"
		err = user.Add()
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, "用户信息录入失败", nil)
			return
		}
		wxuser, err = user.SelectOneByOpenid()
		if err != nil {
			supports.Error(ctx, iris.StatusBadRequest, "用户信息查询失败", nil)
			return
		}
	} else {
		ok := wxfunc.ValidateUserInfo(data.RawData, wxuser.Sessionkey, data.Signatrue)
		if !ok {
			//过期，更新
			user.Uid = wxuser.Uid
			//user.Sessionkey = wxLoginResp.SessionKey
			user.Sessionkey = "123456"
			err = user.Update()
			if err != nil {
				supports.Error(ctx, iris.StatusBadRequest, "用户信息更新失败", nil)
				return
			}
		}
	}

	supports.Ok(ctx, supports.OptionSuccess, wxuser)
}

//查询是否已经做过调查
func WxCheckResult(ctx iris.Context) {

	cache := new(wxSmall.WxUserCache)
	cache.Cid, _ = ctx.URLParamInt("cid")
	cache.Uid, _ = ctx.URLParamInt("uid")
	cache.Surveysheetid = ctx.URLParam("surveysheetid")
	ok, err := cache.SelectResultInfo()
	if err != nil {
		supports.Error(ctx, iris.StatusBadRequest, supports.ParseParamsFailur, nil)
		return
	}
	if ok {
		supports.Ok(ctx, supports.OptionSuccess, true)
	} else {
		supports.Ok(ctx, supports.OptionSuccess, false)
	}

}

//判断二维码是否过期
func WxCheckBarcode(ctx iris.Context) {

	me := new(models.CSurveysheet)
	me.Cid, _ = ctx.URLParamInt("cid")
	me.Cnr, _ = ctx.URLParamInt("cid")
	lenDays, _ := ctx.URLParamInt("lenDays")
	me.Surveysheetid = ctx.URLParam("surveysheetid")
	result, err := me.SelectInfo()
	if err != nil {
		supports.Error(ctx, iris.StatusBadRequest, err.Error(), nil)
		return
	}
	fmt.Println(result)
	if utils.ValueIsEmpty(result.Surveydate) {
		supports.Ok(ctx, supports.OptionSuccess, "没有设置调研时间!")
		return
	}
	nowDate := time.Now()
	begDate,_ := utils.TimeParseyyyyMMdd(result.Surveydate)
	endDate := begDate.AddDate(0,0,lenDays)
	//判断
	if nowDate.Before(begDate){
		supports.Ok(ctx, supports.OptionSuccess, "未开始")
	}
	if nowDate.After(begDate) &&  nowDate.Before(endDate){
		supports.Ok(ctx, supports.OptionSuccess, "未过期")
	} else {
		supports.Ok(ctx, supports.OptionSuccess, "已过期")
	}

}
